SystemOrganization addCategory: #'Sudoku-Tenn2'!

FileStream subclass: #SudokuFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuFileTest methodsFor: 'as yet unclassified' stamp: 'DWT 5/10/2012 09:01'!
checkForFile: filename
	"this needs to be written"! !

!SudokuFileTest methodsFor: 'as yet unclassified' stamp: 'DWT 6/14/2012 11:30'!
fileNew: filename
	| stream |
	"this needs to be written"
	"stream := FileStream forceNewFileNamed: (#filename asString, '.sdk') asString." 
	stream := FileStream forceNewFileNamed: 'sudokutest.sdk' asString.
	stream 
		"nextPutAll: 'This is the latest TEXT';
		nextPutAll: 'This text is written in a file named ';
		nextPutAll: (filename)asString; 
		print: stream localName. "
		
		
	stream  close.
	! !

!SudokuFileTest methodsFor: 'as yet unclassified' stamp: 'DWT 5/10/2012 09:03'!
fileOpen: filename
	"this needs to be written"! !

!SudokuFileTest methodsFor: 'as yet unclassified' stamp: 'DWT 5/10/2012 09:03'!
fileSave: filename
	"this needs to be written"! !

!SudokuFileTest methodsFor: 'as yet unclassified' stamp: 'DWT 5/10/2012 09:00'!
initialize
	super initialize.! !

BorderedMorph subclass: #Sudoku
	instanceVariableNames: 'sudokuGame'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Sudoku-Tenn2'!

!Sudoku methodsFor: 'as yet unclassified' stamp: 'Dt 1/13/2013 16:24'!
fileNew: filename
	| stream gameValues epmtyTest |
	
	gameValues:= 'This is the sudoku game ', filename, ' saved on: ',  Date today, '.', CR.
	
	1 to: 9 do: [:row| 
		
		1 to: 9 do: [:column| 
			epmtyTest := (sudokuGame getGridCellValue: row column: column).
			
			(epmtyTest = '') 
				ifTrue:[gameValues:= gameValues, '0 '] 
				ifFalse:[gameValues:= gameValues, epmtyTest, ' '].
			].
		gameValues := gameValues, CR
		].
	
			
	stream := FileStream forceNewFileNamed: (filename asString, '.sdk') asString. 

	stream 
	
	nextPutAll: gameValues asString;
	close.! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 6/14/2012 11:35'!
initialize
	super initialize.
	self borderWidth: 0.
	self color: Color lightYellow.
	self extent: 9*(52.5@52.5).
	
	sudokuGame:= SudokuGrid new.
	self addMorph: sudokuGame.
	
	! !

BorderedMorph subclass: #SudokuBlock
	instanceVariableNames: 'values cell1 cell2 cell3 cell4 cell5 cell6 cell7 cell8 cell9 cellNumber cellObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/22/2012 15:30'!
addressToCellNumber: aRow and: aColumn

	( (aRow isInteger
		and: [aRow >= 1]
		and: [aRow < 4]) and:
		
		(aColumn isInteger
		and: [aColumn >= 1]
		and: [aColumn < 4]) )
		
	"ifTrue: [cellNumber:=  'cell', ((3*(aRow-1) + aColumn)) asString ] "
	"Insert BRUTE FORCE ..."
	ifTrue: [cellNumber:= 3*(aRow-1) + aColumn ]
! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/2/2012 12:29'!
availableValues
	^values   "This is an array of available numbers to put in the block"! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 6/21/2012 17:33'!
getCellValue: aRow and: aColumn
	| aCellValue |
	self addressToCellNumber: aRow and: aColumn.
			
			(cellNumber = 1) ifTrue: [aCellValue:= cell1 cellValue].
			(cellNumber = 2) ifTrue: [aCellValue:= cell2 cellValue].
			(cellNumber = 3) ifTrue: [aCellValue:= cell3 cellValue].
			(cellNumber = 4) ifTrue: [aCellValue:= cell4 cellValue].
			(cellNumber = 5) ifTrue: [aCellValue:= cell5 cellValue].
			(cellNumber = 6) ifTrue: [aCellValue:= cell6 cellValue].
			(cellNumber = 7) ifTrue: [aCellValue:= cell7 cellValue].
			(cellNumber = 8) ifTrue: [aCellValue:= cell8 cellValue].
			(cellNumber = 9) ifTrue: [aCellValue:= cell9 cellValue].
			
	^aCellValue.

			

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 11:19'!
initialize
	super initialize.
	self	borderColor: Color red.
	self	borderWidth: 5.
	self 	extent: 3*(53@53).  "better to use extent property NOT 55@55"
	self	color: Color lightYellow.
	"values:= {1, 2, 3, 4, 5, 6, 7, 8, 9}. "      "these are all valid values in the block at init."
	"as they get used up just delete them, if they become unused, put them back in"
	
	"I'm sure there is a better way to do it, but I don't know how right now"
	cell1:= SudokuCell new.
	cell1 position: 0@0.
	self addMorph: cell1.
	cell2:= SudokuCell new.
	cell2 position: 52@0.
	self addMorph: cell2.
	cell3:= SudokuCell new.
	cell3 position: 104@0.
	self addMorph: cell3.
	
	cell4:= SudokuCell new.
	cell4 position: 0@52.
	self addMorph: cell4.
	cell5:= SudokuCell new.
	cell5 position: 52@52.
	self addMorph: cell5.
	cell6:= SudokuCell new.
	cell6 position: 104@52.
	self addMorph: cell6.
	
	cell7:= SudokuCell new.
	cell7 position: 0@104.
	self addMorph: cell7.
	cell8:= SudokuCell new.
	cell8 position: 52@104.
	self addMorph: cell8.
	cell9:= SudokuCell new.
	cell9 position: 104@104.
	self addMorph: cell9.
	
	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/26/2012 08:07'!
lockCell: aBoolean row: aRow column: aColumn

	"^'addressToCellNumber: aRow and: aColumn' cellValue: aValue"
	self addressToCellNumber: aRow and: aColumn.
	(aBoolean isKindOf: Boolean)		
		ifTrue: [
			(cellNumber = 1) ifTrue: [cell1 cellLock: aBoolean].
			(cellNumber = 2) ifTrue: [cell2 cellLock: aBoolean].
			(cellNumber = 3) ifTrue: [cell3 cellLock: aBoolean].
			(cellNumber = 4) ifTrue: [cell4 cellLock: aBoolean].
			(cellNumber = 5) ifTrue: [cell5 cellLock: aBoolean].
			(cellNumber = 6) ifTrue: [cell6 cellLock: aBoolean].
			(cellNumber = 7) ifTrue: [cell7 cellLock: aBoolean].
			(cellNumber = 8) ifTrue: [cell8 cellLock: aBoolean].
			(cellNumber = 9) ifTrue: [cell9 cellLock: aBoolean].
			].
			
	

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:21'!
reclaimAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:20'!
removeAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 16:03'!
setCellValue: aValue row: aRow column: aColumn
	"^'addressToCellNumber: aRow and: aColumn' cellValue: aValue"
	self addressToCellNumber: aRow and: aColumn.
	(aValue isInteger
		and: [aValue >= 0]
		and: [aValue < 10])
		
		ifTrue: [
			(cellNumber = 1) ifTrue: [cell1 cellValue: aValue].
			(cellNumber = 2) ifTrue: [cell2 cellValue: aValue].
			(cellNumber = 3) ifTrue: [cell3 cellValue: aValue].
			(cellNumber = 4) ifTrue: [cell4 cellValue: aValue].
			(cellNumber = 5) ifTrue: [cell5 cellValue: aValue].
			(cellNumber = 6) ifTrue: [cell6 cellValue: aValue].
			(cellNumber = 7) ifTrue: [cell7 cellValue: aValue].
			(cellNumber = 8) ifTrue: [cell8 cellValue: aValue].
			(cellNumber = 9) ifTrue: [cell9 cellValue: aValue].
			].
			
	

	! !

BorderedMorph subclass: #SudokuCell
	instanceVariableNames: 'cellValue cellRow cellColumn cellBlockNumber cellContents cellText cellLocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellBlockNumber
	^cellBlockNumber.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:09'!
cellBlockNumber: aNumber
	"Set the block number value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellBlockNumber:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellColumn
	^cellColumn.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:10'!
cellColumn: aNumber
	"Set the column value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellColumn:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellLock
	^cellLocked.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:10'!
cellLock: aBoolean
	"Set the lock to disable changing cellContents"
	(aBoolean isKindOf: Boolean)      "Squeak doesn't appear to know about isBoolean"
		ifTrue: [cellLocked:= aBoolean].
		
	"Note, SBE-183 says that isBoolean, isInteger kind of methods violate the principle of encapsulation, and that you should query the object instead ... no examples are given, and SBE is inconsistent in giving its code examples, since it uses this very feature."! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellRow
	^cellRow.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellRow: aNumber
	"Set the row value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellRow:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellValue
	^cellContents.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 18:12'!
cellValue: aNumber
	"Set the shown number for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellValue:= aNumber.
			cellContents:= cellValue asString.
			self changed].
		(aNumber = 0and: [cellLocked = false]) 
		ifTrue: [cellContents:= ''.
			self changed].! !

!SudokuCell methodsFor: 'drawing' stamp: 'DWT 4/26/2012 09:18'!
drawOn:  aCanvas 
	super drawOn: aCanvas. 
		(self cellLock) ifTrue: [cellText color: Color red].
		(self cellLock) ifFalse: [cellText color: Color black].
		cellText contents: cellContents.

! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 16:18'!
eraseCellValue
	"Set the shown number for the Sudoku cell."
	
	(cellLocked:= false)
		ifTrue: [cellContents:= ' ']
! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/26/2012 08:19'!
handleKeystroke: anEvent 
	| keyStroke |
	keyStroke:= anEvent keyValue.
	"ASCII 48 is the number 0, and ASCII 57 is the number 9"
	(keyStroke > 47 and: [keyStroke < 58])
		ifTrue: [self cellValue: (keyStroke-48)]. 
	"ASCII 108 is the letter l, for lock"
	(keyStroke = 108) ifTrue: [self cellLock: true].
	"ASCII 117 is the letter u, for unlock"
	(keyStroke = 117) ifTrue: [self cellLock: false].
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:29'!
handlesMouseOver: anEvent
	^true! !

!SudokuCell methodsFor: 'initialization' stamp: 'DWT 4/26/2012 09:19'!
initialize
	super initialize.
	self extent: 55@55.
	self borderWidth: 1.
	self borderColor: (Color blue alpha: 0.4).
	self color: Color lightYellow.
	cellContents := ''.
	cellLocked:= false.       "Use lock for generated suduko numbers in cell, use (bold)."
	cellRow:= 0.					  "Row, column and block number are defined when a new block is created"
	cellColumn:= 0.                 
	cellBlockNumber:=0.
	cellText:= StringMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))
		
	
"*** This was my first working bit, but I don't know how to communicate to it, so I thought it would be best to
try to instantiate an object, which then should be accesible:

self addMorph: ((StringMorph contents: cellContents)
		center: self position + 0.5*(self extent))"
		
"**************************************************************************"
		
"*** How to use TextMorph ... the problem here is that it also takes over the keyboard, and it doesn't seem to 
have any value to inspect: 

	cellText:= TextMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))"
	
	
	
	
	
	 ! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseEnter: anEvent 
	anEvent hand newKeyboardFocus: self.
	self color: Color yellow.
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil.
	self color: Color lightYellow.! !

BorderedMorph subclass: #SudokuGrid
	instanceVariableNames: 'block1 block2 block3 block4 block5 block6 block7 block8 block9 blockNumber cellRow cellColumn cellNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 6/14/2012 12:00'!
getGridCellValue:  aGridRow column: aGridColumn
	| aGridValue |
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	
			(blockNumber = 1) ifTrue: [aGridValue:= block1  getCellValue: cellRow and: cellColumn].
			(blockNumber = 2) ifTrue: [aGridValue:= block2  getCellValue: cellRow and: cellColumn].
			(blockNumber = 3) ifTrue: [aGridValue:= block3  getCellValue: cellRow and: cellColumn].
			(blockNumber = 4) ifTrue: [aGridValue:= block4  getCellValue: cellRow and: cellColumn].
			(blockNumber = 5) ifTrue: [aGridValue:= block5  getCellValue: cellRow and: cellColumn].
			(blockNumber = 6) ifTrue: [aGridValue:= block6  getCellValue: cellRow and: cellColumn].
			(blockNumber = 7) ifTrue: [aGridValue:= block7  getCellValue: cellRow and: cellColumn].
			(blockNumber = 8) ifTrue: [aGridValue:= block8  getCellValue: cellRow and: cellColumn].
			(blockNumber = 9) ifTrue: [aGridValue:= block9  getCellValue: cellRow and: cellColumn].
			
			^aGridValue.
		! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 10:07'!
gridAddressToCellNumber: aGridRow and: aGridColumn
	| rowGroup columnGroup |
	( (aGridRow isInteger
		and: [aGridRow >= 1]
		and: [aGridRow < 10]) and:
		
		(aGridColumn isInteger
		and: [aGridColumn >= 1]
		and: [aGridColumn < 10]) )
		
	"ifTrue: [gridCellNumber:=  'cell', ((3*(aGridRow-1) + aGridColumn)) asString ] "
	"Insert BRUTE FORCE ..."
	
	ifTrue: [ 
		((aGridRow >=1) and: [aGridRow < 4]) ifTrue: [rowGroup:= 1].
		((aGridRow >=4) and: [aGridRow < 7]) ifTrue: [rowGroup:= 2].
		((aGridRow >=7) and: [aGridRow < 10]) ifTrue: [rowGroup:= 3].
		
		((aGridColumn >=1) and: [aGridColumn < 4]) ifTrue: [columnGroup:= 1].
		((aGridColumn >=4) and: [aGridColumn < 7]) ifTrue: [columnGroup:= 2].
		((aGridColumn >=7) and: [aGridColumn < 10]) ifTrue: [columnGroup:= 3].
		
		blockNumber:=  3*(rowGroup-1) + columnGroup .
		
		cellRow:= aGridRow - (3*(rowGroup-1)).
		
		cellColumn:= aGridColumn - (3*(columnGroup-1)).
		
		cellNumber:= 3*(cellRow-1) + cellColumn.
		].
! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 2/9/2012 12:10'!
initialize
	super initialize.
	self 	extent: 9*(52.5@52.5).
	self	borderWidth: 1.
	self	color: Color lightYellow.
		
	"I'm sure there is a better way to do it, but I don't know how right now"
	block1:= SudokuBlock new.
	block1 position: 0@0.
	self addMorph: block1.
	block2:= SudokuBlock new.
	block2 position: 156@0.
	self addMorph: block2.
	block3:= SudokuBlock new.
	block3 position: 312@0.
	self addMorph: block3.
	
	block4:= SudokuBlock new.
	block4 position: 0@156.
	self addMorph: block4.
	block5:= SudokuBlock new.
	block5 position: 156@156.
	self addMorph: block5.
	block6:= SudokuBlock new.
	block6 position: 312@156.
	self addMorph: block6.
	
	block7:= SudokuBlock new.
	block7 position: 0@312.
	self addMorph: block7.
	block8:= SudokuBlock new.
	block8 position: 156@312.
	self addMorph: block8.
	block9:= SudokuBlock new.
	block9 position: 312@312.
	self addMorph: block9.
		
		


	! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 4/26/2012 08:06'!
lockGridCell: aBoolean row: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aBoolean isKindOf: Boolean)
			ifTrue: [
			(blockNumber = 1) ifTrue: [block1 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 2) ifTrue: [block2 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 3) ifTrue: [block3 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 4) ifTrue: [block4 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 5) ifTrue: [block5 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 6) ifTrue: [block6 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 7) ifTrue: [block7 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 8) ifTrue: [block8 lockCell: aBoolean row: cellRow column: cellColumn].
			(blockNumber = 9) ifTrue: [block9 lockCell: aBoolean row: cellRow column: cellColumn].
			].! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 4/19/2012 10:27'!
setGridCellValue: aGridCellValue row: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aGridCellValue isInteger
		and: [aGridCellValue >= 1]
		and: [aGridCellValue < 10])
		
			ifTrue: [
			(blockNumber = 1) ifTrue: [block1 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 2) ifTrue: [block2 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 3) ifTrue: [block3 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 4) ifTrue: [block4 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 5) ifTrue: [block5 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 6) ifTrue: [block6 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 7) ifTrue: [block7 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 8) ifTrue: [block8 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			(blockNumber = 9) ifTrue: [block9 setCellValue: aGridCellValue row: cellRow column: cellColumn].
			].! !

BorderedMorph subclass: #SudokuTest
	instanceVariableNames: 'receiver message result argument keyword1 keyword2 argument1 argument2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuTest methodsFor: 'as yet unclassified' stamp: 'DWT 4/23/2012 22:26'!
binaryMessage
	"trying to understand how the dynamic building of a message works"
	"the message here is: 1 + 2"
	receiver := 1.
	message := '+' asSymbol.
	argument := 2.
	"Each of the next three lines give the same result in different ways:"
	"result := receiver perform: message withArguments: (Array with: argument)."
	"result := Compiler evaluate: ((receiver storeString), ' ', message, ' ', (argument storeString))."
	result := (Message new setSelector: message arguments: (Array with: argument)) sentTo: receiver.
	^ result. ! !

!SudokuTest methodsFor: 'as yet unclassified' stamp: 'DWT 2/11/2012 21:23'!
initialize
	super initialize.
	
	"n:= 1.
	9 timesRepeat: [
		block "
	! !

!SudokuTest methodsFor: 'as yet unclassified' stamp: 'DWT 4/23/2012 22:33'!
keywordMessage
	"trying to understand how the dynamic building of a message works"
	"the message here is: 12 between: 10 and: 20"
	receiver := 12.
	keyword1 := 'between:' asSymbol.
	keyword2 := 'and:' asSymbol.
	argument1 := 10.
	argument2 := 20.
	result := receiver
		perform: (keyword1, keyword2) asSymbol
		withArguments: (Array with: argument1 with: argument2).
	^ result. ! !

!SudokuTest methodsFor: 'as yet unclassified' stamp: 'DWT 4/23/2012 22:20'!
unaryMessage
	"trying to understand how the dynamic building of a message works"
	"the message here is: 5 factorial"
	receiver:= 5.
	message:= 'factorial' asSymbol.
	"Each of the next two lines work fine (individually)"
	"result:= receiver perform: message. "
	"result:= Compiler evaluate: ((receiver storeString), ' ',message)."
     result:= (Message new setSelector: message arguments: #()) sentTo: receiver.
	^ result. ! !
